import type { NextPage } from "next";
import Head from "next/head";
import Link from "next/link";
import { useCallback, useState } from "react";
import { signIn } from "next-auth/react";
import { useForm } from "react-hook-form";
import { zodResolver } from "@hookform/resolvers/zod";

import { loginSchema, ILogin } from "../common/validation/auth";
import { useRouter } from "next/router";

const Login: NextPage = () => {
  const router = useRouter();
  const [invalid, setInvalid] = useState(false);
  const { register, handleSubmit } = useForm<ILogin>({
    resolver: zodResolver(loginSchema),
  });

  const onSubmit = useCallback(async (data: ILogin) => {
    const result = await signIn("credentials", {
      redirect: false,
      email: data.email,
      password: data.password,
    });

    if (!result) return;

    if (result.error) {
      setInvalid(true);
      return;
    }

    if (result.ok) router.push("/");
  }, []);

  return (
    <div>
      <Head>
        <title>Next App - Login</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="icon" href="/favicon.ico" />
      </Head>

      <main>
        <form
          className="flex items-center justify-center h-screen w-full"
          onSubmit={handleSubmit(onSubmit)}
        >
          <div className="card w-96 bg-base-100 shadow-xl">
            <div className="card-body">
              <h2 className="card-title">Welcome back!</h2>
              <input
                type="email"
                placeholder="Type your email..."
                className={`input input-bordered w-full max-w-xs my-2 ${
                  invalid ? "input-error" : ""
                }`}
                {...register("email")}
                onChange={() => setInvalid(false)}
              />
              <input
                type="password"
                placeholder="Type your password..."
                className={`input input-bordered w-full max-w-xs my-2 ${
                  invalid ? "input-error" : ""
                }`}
                {...register("password")}
                onChange={() => setInvalid(false)}
              />
              {invalid && (
                <p className="text-error">Invalid email or password</p>
              )}
              <div className="card-actions items-center justify-between">
                <Link href="/signup" className="link">
                  Go to sign up
                </Link>
                <button className="btn btn-secondary" type="submit">
                  Login
                </button>
              </div>
            </div>
          </div>
        </form>
      </main>
    </div>
  );
};

export default Login;
